/*
 * Copyright (C) 2026  Tim Zimmermann <tim@aglais.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.aglais.zms.server.route.util;

import com.google.gson.Gson;
import io.netty.buffer.ByteBuf;
import io.netty.handler.codec.http.FullHttpRequest;
import io.netty.handler.codec.http.HttpRequest;
import org.aglais.zms.api.core.gson.JsonUtils;

import java.nio.charset.StandardCharsets;

public class RouteUtil {

    private static final Gson GSON = JsonUtils.createGsonInstance();

    public static void writeJson(ByteBuf buf, Object obj) {
        buf.writeCharSequence(GSON.toJson(obj), StandardCharsets.UTF_8);
    }

    public static <T> T readJson(ByteBuf buf, Class<T> clazz) {
        return GSON.fromJson(buf.toString(StandardCharsets.UTF_8), clazz);
    }

    public static <T> T readJson(HttpRequest request, Class<T> clazz) {
        if (request instanceof FullHttpRequest fullRequest)
            return readJson(fullRequest.content(), clazz);

        return null;
    }
}
